<template>
  <fieldset>
    <fieldset class="autocomplete">
      <TextInputFloatingLabel :text="t('station_name_label')" for="stationName">
        <input
            type="text"
            @input="autocompleteStations"
            name="stationName"
            id="stationName"
            class="autocomplete__input"
            :placeholder="t('search for a station')"
            v-model="currentSearch"
        />
      </TextInputFloatingLabel>
      <ul class="autocomplete__list" v-show="stationCandidates.length > 0">
        <li v-show="loadingAutocomplete">{{ t("search_loading_label") }} …</li>
        <li
            v-for="candidate in stationCandidates"
            :key="candidate.StopLocation.extId"
            @click="setStation(candidate)"
            class="autocomplete__list-item"
        >
          {{ candidate.StopLocation.name }}
        </li>
      </ul>
      <input
          type="hidden"
          name="stationId"
          id="stationId"
          :value="currentSettings.stationId"
      />
    </fieldset>
    <fieldset>
      <legend>{{ t("transport_filter_label") }}</legend>
      <div class="vbb-four-up">
        <template v-for="type in $options.transitTypes">
          <CheckBoxBorderedLabel
              :key="type"
              :for="`chosenTransitTypes_${type}`"
              :text="t(type)"
          >
            <input
                type="checkbox"
                name="chosenTransitTypes"
                :id="`chosenTransitTypes_${type}`"
                :value="type"
                :checked="currentSettings.chosenTransitTypes.includes(type)"
            />
          </CheckBoxBorderedLabel>
        </template>
      </div>
    </fieldset>
  </fieldset>
</template>

<script>
module.exports = {
  name: "vbb",
  props: {
    currentSettings: {
      type: Object,
      required: false,
      default: function () {
        return {
          stationName: null,
          stationId: null,
          limit: 5,
          chosenTransitTypes: ["bus", "tram", "ubahn", "sbahn", "rb", "ic"]
        }
      }
    },
    locale: {
      type: String,
      required: false
    }
  },
  transitTypes: ["bus", "tram", "ubahn", "sbahn", "rb", "ic", "ferry"],
  vbbApiKey: "16e07734-4fe4-4209-a228-a337b0fa5445",
  data: function () {
    return {
      stationCandidates: [],
      currentSearch: this.currentSettings.stationName,
      loadingAutocomplete: false
    };
  },
  locales: {
    enGb: {
      search_loading_label: "Loading search results",
      station_name_label: "Station name",
      transport_filter_label: "filter transport types",
      bus: "Bus",
      tram: "Tram",
      ubahn: "Underground",
      sbahn: "Train",
      rb: "Regional train",
      ic: "Intercity (IC)",
      ferry: "Ferry"
    },
    deDe: {
      search_loading_label: "Suchergebnisse laden",
      station_name_label: "Name der Haltestelle",
      transport_filter_label: "Nur diese Fahrzeug-Typen abfragen",
      bus: "Bus",
      tram: "Trambahn",
      ubahn: "U-Bahn",
      sbahn: "S-Bahn",
      rb: "Regionalbahn",
      ic: "Intercity (IC)",
      ferry: "Fähre"
    },
    frFr: {
      search_loading_label: "Chargement des résultats de recherche",
      station_name_label: "Nom de l'arrêt",
      transport_filter_label: "N'interrogez que ces types de véhicules",
      bus: "autobus",
      tram: "tram",
      ubahn: "métro",
      sbahn: "train de banlieue",
      rb: "train régional",
      ic: "interurbain",
      ferry: "bac"
    },
    esEs: {
      search_loading_label: "Cargando los resultados de la búsqueda",
      station_name_label: "Nombre de la parada",
      transport_filter_label: "Consulta sólo estos tipos de vehículos",
      bus: "autobús",
      tram: "tranviario",
      ubahn: "suburbano",
      sbahn: "cajón de sastre",
      rb: "tren regional",
      ic: "interurbano",
      ferry: "trasbordador"
    },
    plPl: {
      search_loading_label: "Ładowanie wyników wyszukiwania",
      station_name_label: "Nazwa stacji",
      transport_filter_label: "Zapytaj tylko o te typy pojazdów.",
      bus: "autobus",
      tram: "tramwaj",
      ubahn: "metro",
      sbahn: "S-Bahn",
      rb: "pociąg regionalny",
      ic: "obcowanie",
      ferry: "prom"
    },
    koKr: {
      search_loading_label: "검색 결과로드",
      station_name_label: "정류장 명",
      transport_filter_label: "이 차량 유형 만 쿼리하십시오",
      bus: "버스",
      tram: "트램",
      ubahn: "지하철",
      sbahn: "S-bahn을 타고",
      rb: "지역 열차",
      ic: "간",
      ferry: "나룻배"
    }
  },
  methods: {
    autocompleteStations: async function (e) {
      this.stationCandidates = [];
      if (e.target.value.length <= 3) {
        return;
      }
      this.loadingAutocomplete = true;
      // FIXME: This relies on axios bein available through vue-axios in the main app.
      const res = await this.axios.get(
          `https://fahrinfo.vbb.de/restproxy/2.4/location.name?accessId=${this.$options.vbbApiKey}&type=S&lang=de&format=json&input=${e.target.value}`
      );
      // TODO: Should we query other languages if configured?

      this.stationCandidates = res.data.stopLocationOrCoordLocation;
      this.loadingAutocomplete = false;
    },
    setStation: function (station) {
      this.currentSettings.stationName = station.StopLocation.name;
      this.currentSettings.stationId = station.StopLocation.extId;
      this.currentSearch = station.StopLocation.name;
      this.stationCandidates = [];
    }
    /* handleStepper: function(direction) {
      switch (direction) {
        case "increment":
          this.currentSettings.limit = Number.parseInt(this.currentSettings.limit) + 1;
          break;
        case "decrement":
          this.currentSettings.limit = Math.max(Number.parseInt(this.currentSettings.limit) - 1, 0);
          break;
        default:
          break;
      }
    } */
  }
};
</script>
<style scoped>
.autocomplete {
  width: 100%;
  position: relative;
  margin-bottom: 1rem;
}

.autocomplete__input {
  margin-bottom: 0;
}

.autocomplete__list {
  list-style-type: none;
  background-color: #fff;
  border: 3px solid #eeeeee;
  box-sizing: border-box;
  max-height: 200px;
  overflow-y: scroll;
  overflow-x: hidden;
  position: absolute;
  width: 100%;
  margin-left: 0;
  margin-block-start: 0;
  margin-block-end: 0;
  z-index: 1;
}

.autocomplete__list-item {
  padding: 0.25rem;
  border-bottom: 1px solid #eeeeee;
}

.autocomplete__list-item:hover {
  background-color: #8ba4c1;
}

.vbb-four-up {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
}

.vbb-four-up > label {
  flex-basis: 45%;
}
</style>
